{
  'variables': {
    'platform': '<(OS)',
  },
  'conditions': [
    # Replace gyp platform with node platform, blech
    ['platform == "mac"', {'variables': {'platform': 'darwin'}}],
    ['platform == "win"', {'variables': {'platform': 'win32'}}],
  ],
  'targets': [
    {
      'target_name': 'webgl',
      'defines': [
        'VERSION=0.5.5'
      ],
      'sources': [
          'src/bindings.cc',
          'src/image.cc',
          'src/webgl.cc',
      ],
      'include_dirs': [
        "<!(node -e \"require('nan')\")",
        '<(module_root_dir)/node_modules/native-graphics-deps/include',
      ],
      'conditions': [
        ['OS=="mac"',
          {
            'libraries': ['-lGLEW','-lfreeimage','-framework OpenGL'],
            'include_dirs': ['/usr/local/include'],
            'library_dirs': ['/usr/local/lib'],
          }
        ],
        ['OS=="linux"', {
          'libraries': [
            '-lfreeimage','-lGLEW','-lGL']
          }
        ],
        ['OS=="win"',
          {
            'include_dirs': [
              './node_modules/native-graphics-deps/include',
              ],
            'library_dirs': [
              './node_modules/native-graphics-deps/windows/lib/<(target_arch)',
              ],
            'libraries': [
              'glew32.lib',
              'opengl32.lib',
              'FreeImage.lib'
              ],
            'defines' : [
              'WIN32_LEAN_AND_MEAN',
              'VC_EXTRALEAN'
            ],
            'msvs_settings' : {
              'VCCLCompilerTool' : {
                'AdditionalOptions' : ['/O2','/Oy','/GL','/GF','/Gm-','/EHsc','/MT','/GS','/Gy','/GR-','/Gd']
              },
              'VCLinkerTool' : {
                'AdditionalOptions' : ['/OPT:REF','/OPT:ICF','/LTCG']
              },
            },
            'copies': [
              {
                'destination': './build/Release/',
                'files': [
                  './node_modules/native-graphics-deps/windows/lib/x64/AntTweakBar.dll',
                  './node_modules/native-graphics-deps/windows/lib/x64/AntTweakBar.lib',
                  './node_modules/native-graphics-deps/windows/lib/x64/AntTweakBar64.dll',
                  './node_modules/native-graphics-deps/windows/lib/x64/AntTweakBar64.lib',
                  './node_modules/native-graphics-deps/windows/lib/x64/FreeImage.dll',
                  './node_modules/native-graphics-deps/windows/lib/x64/FreeImage.lib',
                  './node_modules/native-graphics-deps/windows/lib/x64/glew32.dll',
                  './node_modules/native-graphics-deps/windows/lib/x64/glew32.lib',
                  './node_modules/native-graphics-deps/windows/lib/x64/glew32s.lib',
                  './node_modules/native-graphics-deps/windows/lib/x64/glfw3.dll',
                  './node_modules/native-graphics-deps/windows/lib/x64/glfw3.lib',
                  './node_modules/native-graphics-deps/windows/lib/x64/glfw3dll.lib',
                 ]
              }
            ],
          }
        ],
      ],
    }
  ]
}
